/**********************************************************************
 * File  : game_menus.hpp
 * Author: Lightness1024
 *         mailto:lightness1024@free.fr
 * Date  : 05/05/2009
 *********************************************************************/

#ifndef GAME_MENUS_HPP_INC_05_05_2009___222690991_
#define GAME_MENUS_HPP_INC_05_05_2009___222690991_ 1

#include "solardiales.hpp"
#include "boost/array.hpp"

enum EMainMenuCommands
{
	MC_START,
	MC_EXITGAME,
	MC_CUSTOMIZED_TERRAIN,
	MC_HIGHSCORES,
	MC_SOUND_SETTINGS,
	MC_NONE
};

enum EChoosePlayerMenuCommands
{
	CPMC_BAD_GUY,
	CPMC_MORPH,
	CPMC_RETURN
};

enum EPauseMenuChoice
{
	PMC_CONTINUE,
	PMC_QUIT
};

struct NumeredProgressBar
{
	int prbarid;
	int hudfontid;
	int value;
	int titleid;
	void ChangeValueClamped(int offset, int min, int max)
	{
		value = myutils::clamp(value + offset, min, max);
	}
};

enum ECTMenuObjects
{
	CTMO_WATER,
	CTMO_ROCKS,
	CTMO_TREE,
	CTMO_SIZE,
	CTMO_FLOW,
	CTMO_SEED,
		
	CTMO_NUM_OBJ
};

struct CustomTerrainParams
{
	boost::array<float, NB_KIND_OF_TERRAIN_OBJECTS> density;
	int size_long;
	int flow;
	int seed;
};

class SoundManager;

void DrawShopMenu(Menu& shop_menu, SpriteManager& spm);
void DisplayCreditsScreen(void);
void HighScoresMenu(void);
void PlayMenuOpeningSound(void);
void BuyItem(int menuPosId);

EMainMenuCommands WelcomeMenu(void);
EPauseMenuChoice PauseMenu(void);
EChoosePlayerMenuCommands ChoosePlayerMenu(void);
std::pair< CustomTerrainParams, bool > CustomizeTerrainMenu(CustomTerrainParams const& in_values);
SoundSettings SoundSettingsMenu(int startMusicVolume, SoundManager* menuMusic);
int FinalScoreMenu(int cash_left, int cumulated_cp, bool fast_animation);
void KeySummaryScreen(void);

#endif //GAME_MENUS_HPP_INC_05_05_2009___222690991_
