/**********************************************************************
 * File	: gunner.hpp
 * Author: Lightness1024!
 *			  mailto:lightness1024@free.fr
 * Date	: 31/07/2007
 *********************************************************************/

#ifndef GUNNER_HPP_INC_19_03_2009___70848897_
#define GUNNER_HPP_INC_19_03_2009___70848897_ 1

#include "weaponmanager.hpp"
#include "iaclasses.hpp"

#include <set>
using std::set;

class Gunner : public ia::Class
{
protected:

	set< int > weapons;	 // un gunner possède des armes
	int kills_count;     // nombre de kills
	
	virtual int RaiseScore(int points)
	{
		int raise = points * income_multiplier;
		score += raise;
		return raise;
	}

public:

	Rect rect;				 // rectangle pour aider le weaponmanager a determiner les positions de depart des tirs
	Vector2f direction;	     // direction car meme raison.
	float angle;			 // et ca pour eviter un arctangent.

	int score;				 // un score, pour etre recompensé des tirs réussis.
	int income_multiplier;   // multiplicateur de revenus

	bool istower;			 // une tourelle est moins puissante qu'un tireur normal

	// il peut recevoir des armes
	void GiveWeapon(int index)
	{
		weapons.insert(index);
	}

	// il peut informer de sa possession d'une arme
	bool WeaponPresent(int id) const
	{
		return weapons.find(id) != weapons.end();
	}

	virtual void SignalKills(int kill_num)
	{
		kills_count += kill_num;
		RaiseScore(kill_num * SCORE_PER_KILL);
	}

	// donne ses kills a quelqu'un d'autre
	virtual void TransferKills(Gunner* creditRecipient)
	{
		creditRecipient->SignalKills(GetKillCount());
		kills_count = 0;
	}

	// il peut informer (le weaponmanager notamment) du centre de depart de tir
	virtual Vector2f GetFireStartCenter(void) const
	{
		return rect.GetCenter();
	}

	// et de la direction principale de tir
	virtual Vector2f GetMainFireDirection(void) const
	{
		return direction;
	}

	// l'angle
	virtual float GetAngle(void) const
	{
		return angle;
	}

	// les offsets
	virtual Vector2i GetSideOffsets(void) const
	{
		return Vector2i((rect.w >> 1) - 1,
						(rect.h >> 1) - 1);
	}

	// le nombre de kills
	virtual int GetKillCount(void) const
	{
		return kills_count;
	}

	Gunner(void)
			: kills_count(0),
			  direction(0, 1),
			  angle(0.f),
			  score(0),
			  istower(false) { }

	virtual ~Gunner() { }
};

#endif //GUNNER_HPP_INC_19_03_2009___70848897_
