/**********************************************************************
 * File	: collisionmanager.hpp
 * Author: Lightness1024!
 *			  mailto:lightness1024@free.fr
 * Date	: 02/08/2007
 *********************************************************************/

#include "collisionmanager.hpp"
#include "terraingenerator.hpp"
#include "towermanager.hpp"
#include "supramanager.hpp"

// dans ces fonctions on va regrouper tous les trucs avec lesquels on peut collisionner.
// le collision and probing n'est qu'une uniformisation de l'interface des differents managers.

int CollisionsAndProbing::instances = 0;

bool CollisionsAndProbing::IntersectRect(const Rect& rc)
{
	if (ChiefManager::GetTerrainManager()->WorldIntersectRect(rc))
		return true;
	if (ChiefManager::GetTowerManager()->TowerIntersectRect(rc))
		return true;
	return false;
}

bool CollisionsAndProbing::IntersectORect(const ORect& orc)
{
	if (ChiefManager::GetTerrainManager()->WorldIntersectORect(orc))
		return true;
	if (ChiefManager::GetTowerManager()->TowerIntersectORect(orc))
		return true;
	return false;
}

bool CollisionsAndProbing::IntersectRay(float* t, const Vector2f& start, const Vector2f& direction, bool probe, bool lowspan)
{
	if (ChiefManager::GetTerrainManager()->WorldIntersectRay(t, start, direction, probe, lowspan))
		return true;
	if (probe)
		if (ChiefManager::GetTowerManager()->TowerIntersectProbeRay(t, start, direction))
			return true;
	return false;
}
