/**********************************************************************
 * File	: collisionmanager.hpp
 * Author: Lightness1024!
 *			  mailto:lightness1024@free.fr
 * Date	: 02/08/2007
 *********************************************************************/

#ifndef COLLISIONMANAGER_HPP_INC_19_03_2009__20416724_
#define COLLISIONMANAGER_HPP_INC_19_03_2009__20416724_ 1

#include "geometry.hpp"

class TowerManager;
class TerrainManager;
class CarsManager;

class CollisionsAndProbing
{
	static int instances;
		
public:
		
	bool IntersectRect(const Rect& rc);
		
	bool IntersectORect(const ORect& orc);
		
	bool IntersectRay(float* t, const Vector2f& start, const Vector2f& direction, bool probe = false, bool lowspan = true);
	struct TooManyInstances {};
		
	CollisionsAndProbing(void)
	{
		if (++instances != 1)
			throw TooManyInstances();
	}
	~CollisionsAndProbing()
	{
		--instances;
	}
};

#endif //COLLISIONMANAGER_HPP_INC_19_03_2009__20416724_
