/**********************************************************************
 * File	: supramanager.hpp
 * Author: Lightness1024!
 *			  mailto:lightness1024@free.fr
 * Date	: 03/08/2007
 *********************************************************************/

#ifndef SUPRAMANAGER_HPP_INC_19_03_2009__226729965_
#define SUPRAMANAGER_HPP_INC_19_03_2009__226729965_ 1

#include <cstddef>

// le chef manager regroupe des pointeurs vers les instances des autres managers

class TerrainManager;
class CarsManager;
class HostilesManager;
class WeaponManager;
class TowerManager;
class CollisionsAndProbing;
class SoundManager;
class ProximityManager;
class HighscoreManager;
namespace ia
{
	class ManagerBase;
}

class ChiefManager
{
	static TerrainManager* p_terrain;
	static CarsManager* p_cars;
	static HostilesManager* p_hostiles;
	static WeaponManager* p_weapons;
	static TowerManager* p_towers;
	static CollisionsAndProbing* p_collisions;
	static SoundManager* p_sound;
	static ProximityManager* p_proximity;
	static HighscoreManager* p_highScores;
	static ia::ManagerBase* p_iaManager;

	// zone privee.
	// aucun interet d'instancier une classe où tout est statique toute facon.
	ChiefManager(void)
	{}

public:

	static void SetManagersPointers(TerrainManager* ap_terrain,
									CarsManager* ap_cars,
									HostilesManager* ap_hostiles,
									WeaponManager* ap_weapons,
									TowerManager* ap_towers,
									CollisionsAndProbing* ap_collisions,
									SoundManager* ap_sound,
									ProximityManager* ap_prox,
									HighscoreManager* ap_hsmgr,
									ia::ManagerBase* ap_iaMgr)
	{
		p_terrain = ap_terrain;
		p_cars = ap_cars;
		p_hostiles = ap_hostiles;
		p_weapons = ap_weapons;
		p_towers = ap_towers;
		p_collisions = ap_collisions;
		p_sound = ap_sound;
		p_proximity = ap_prox;
		p_highScores = ap_hsmgr;
		p_iaManager = ap_iaMgr;
	}
	
	static void ResetAll()
	{
		p_terrain = 0;
		p_cars = 0;
		p_hostiles = 0;
		p_weapons = 0;
		p_towers = 0;
		p_collisions = 0;
		p_sound = 0;
		p_proximity = 0;
		p_highScores = 0;
		p_iaManager = 0;
	}

	static TerrainManager* GetTerrainManager(void)
	{
		return p_terrain;
	}

	static CarsManager* GetCarsManager(void)
	{
		return p_cars;
	}

	static HostilesManager* GetHostilesManager(void)
	{
		return p_hostiles;
	}

	static WeaponManager* GetWeaponManager(void)
	{
		return p_weapons;
	}

	static TowerManager* GetTowerManager(void)
	{
		return p_towers;
	}

	static CollisionsAndProbing* GetCollisionsAndProbing(void)
	{
		return p_collisions;
	}

	static SoundManager* GetSoundManager(void)
	{
		return p_sound;
	}

	static ProximityManager* GetProximityManager(void)
	{
		return p_proximity;
	}
	
	static HighscoreManager* GetHighScoreManager(void)
	{
		return p_highScores;
	}
	
	static ia::ManagerBase* GetIAManager(void)
	{
		return p_iaManager;
	}
};

#endif //SUPRAMANAGER_HPP_INC_19_03_2009__226729965_
