/**********************************************************************
 * File  : screen_inertia.cpp
 * Author: Lightness1024
 *         mailto:lightness1024@free.fr
 * Date  : 05/05/2009
 *********************************************************************/

#include "screen_inertia.hpp"

void Screen::MoveMagnetCenter(const Vector2i& center)
{
	const int demirx = scr.w >> 1;  // div2
	const int demiry = scr.h >> 1;
	Vector2i inRect = center - scr.pos;
	// recuperation des distances vers les paroies les plus proches :
	int vx, vy;
	Vector2f oposite(1.f, 1.f);
	if (inRect.x < demirx)
	{
		vx = inRect.x;
		oposite.x = -1.f;
	}
	else
	{
		vx = scr.w - inRect.x;
	}
	if (inRect.y < demiry)
	{
		vy = inRect.y;
		oposite.y = -1.f;
	}
	else
	{
		vy = scr.h - inRect.y;
	}

	// determiner le vecteur force :
	force.x = repulsion_d.x - std::min<float>(vx, repulsion_d.x);
	force.y = repulsion_d.y - std::min<float>(vy, repulsion_d.y);
	force.x *= oposite.x;
	force.y *= oposite.y;
}

void Screen::Update(float delta_time)
{
	Vector2f accel;
	Vector2f friction;
	Vector2f result;

	friction = speed * 0.7;
	result = force - friction;
	accel = result * (1.f / mass);
	speed += accel * delta_time;
	pos += speed * delta_time;
	scr.pos.x = (int)pos.x;
	scr.pos.y = (int)pos.y;
}
