/**********************************************************************
 * File  : screen_inertia.hpp
 * Author: Lightness1024
 *         mailto:lightness1024@free.fr
 * Date  : 05/05/2009
 *********************************************************************/

#ifndef SCREEN_INERTIA_HPP_INC_05_05_2009___100156448_
#define SCREEN_INERTIA_HPP_INC_05_05_2009___100156448_ 1

#include "geometry.hpp"


// ------------------------
// gerer le scrolling de suivi
// du joueur.
// ------------------------
// handles screen fancy functions
// like soft scroll pushing
// ------------------------
class Screen
{
	Rect scr;

	Vector2f pos;
	Vector2f repulsion_d;
	float mass;
	Vector2f speed;
	Vector2f force;

public:

	void ForceScreenPosition(Vector2i const & a_pos)
	{
		pos = a_pos;
	}

	void MoveMagnetCenter(const Vector2i& center);
	const Rect& GetRc(void) const
	{
		return scr;
	}

	void Update(float delta_time);

	// on donne les infos a la construction :
	Screen(int resX, int resY, int initCenterX, int initCenterY)
			: scr(initCenterX - resX / 2,
				  initCenterY - resY / 2,
				  resX,
				  resY),
			  pos(scr.pos.x, scr.pos.y),	 // int vers float
			  repulsion_d(resX/2, resY/2),
			  mass(0.1f),
			  speed(0, 0)
	{ }
};

#endif //SCREEN_INERTIA_HPP_INC_05_05_2009___100156448_
