/**********************************************************************
 * File  : sdl_events.cpp
 * Author: Lightness1024
 *         mailto:lightness1024@free.fr
 * Date  : 05/05/2009
 *********************************************************************/

#include "sdl_events.hpp"
#include "game_menus.hpp"
#include "solardiales.hpp"
#include "supramanager.hpp"

void HandleEvent(SDL_Event event)
{
	if (!game_vars::shop::g_menuActivated)
	{
		switch (event.type)
		{
			/* close button clicked */
			case SDL_QUIT:
				game_vars::gameover = 1;
				break;

				/* handle the keyboard */

			case SDL_KEYDOWN:
				switch (event.key.keysym.sym)
				{
					case SDLK_ESCAPE:
					case SDLK_q:
						game_vars::gameover = 1;
						break;
					case SDLK_LEFT:
						if (game_vars::g_keyright)
							game_vars::g_user->SetDirection(Car::DIR_STRAIGHT);
						else
							game_vars::g_user->SetDirection(Car::DIR_LEFT);
						game_vars::g_keyleft = true;
						break;
					case SDLK_RIGHT:
						if (game_vars::g_keyleft)
							game_vars::g_user->SetDirection(Car::DIR_STRAIGHT);
						else
							game_vars::g_user->SetDirection(Car::DIR_RIGHT);
						game_vars::g_keyright = true;
						break;
					case SDLK_UP:
						if (game_vars::g_cheat || game_vars::g_carControlDevice)
						{
							game_vars::g_user->speed += GetNormalSpeed();
							if (game_vars::g_user->speed > GetFastSpeed() && !game_vars::g_cheat)
								game_vars::g_user->speed = GetFastSpeed();
						}
						else
							game_vars::g_user->speed = GetNormalSpeed();
						SetEngineSound();	  // si on accelere on change le son du moteur
						break;
					case SDLK_DOWN:
						if (game_vars::g_cheat || game_vars::g_carControlDevice)
						{
							game_vars::g_user->speed -= GetNormalSpeed();
							if (game_vars::g_user->speed < -GetFastSpeed() && !game_vars::g_cheat)
								game_vars::g_user->speed = -GetFastSpeed();
						}
						else
							game_vars::g_user->speed = 0.0f;
						SetEngineSound();	  // pareil si on decelere
						break;
					case SDLK_SPACE:
						if (game_vars::g_keyleft && game_vars::g_keyright)
						{
							game_vars::shop::g_menuActivated = true;		// le menu s'active en combinant les 3 touches
							PlayMenuOpeningSound();
						}
						else
						{
							if (game_vars::g_user->health > 0)
							{
								ChiefManager::GetWeaponManager()->OpenFire(&(*game_vars::g_user), game_vars::g_currentWeapon);
							}
						}
						break;
					case SDLK_m:
					case SDLK_b:
						ChiefManager::GetWeaponManager()->CeaseFire(&(*game_vars::g_user));
						game_vars::g_user->SetDirection(Car::DIR_STRAIGHT);
						game_vars::shop::g_menuActivated = true;			  // ou avec M ou B
						PlayMenuOpeningSound();
					default:
						break;
				}
				break;
			case SDL_KEYUP:
				switch (event.key.keysym.sym)
				{
					case SDLK_LEFT:
						if (game_vars::g_keyright)
							game_vars::g_user->SetDirection(Car::DIR_RIGHT);
						else
							game_vars::g_user->SetDirection(Car::DIR_STRAIGHT);
						game_vars::g_keyleft = false;
						break;
					case SDLK_RIGHT:
						if (game_vars::g_keyleft)
							game_vars::g_user->SetDirection(Car::DIR_LEFT);
						else
							game_vars::g_user->SetDirection(Car::DIR_STRAIGHT);
						game_vars::g_keyright = false;
						break;
					case SDLK_SPACE:
						ChiefManager::GetWeaponManager()->CeaseFire(&(*game_vars::g_user));
					default:
						break;
				}
				break;
			default:
				break;
		}
	}
	else	// menu actif !
	{
		game_vars::g_keyleft = false;
		game_vars::g_keyright = false;
		int menuPosId;
		switch (event.type)
		{
			case SDL_QUIT:
				game_vars::gameover = 1;
				break;
			case SDL_KEYDOWN:
				switch (event.key.keysym.sym)
				{
					case SDLK_0: case SDLK_KP0: { BuyItem(game_vars::shop::g_key_to_id[0].menuid); break; }
					case SDLK_1: case SDLK_KP1: { BuyItem(game_vars::shop::g_key_to_id[1].menuid); break; }
					case SDLK_2: case SDLK_KP2: { BuyItem(game_vars::shop::g_key_to_id[2].menuid); break; }
					case SDLK_3: case SDLK_KP3: { BuyItem(game_vars::shop::g_key_to_id[3].menuid); break; }
					case SDLK_4: case SDLK_KP4: { BuyItem(game_vars::shop::g_key_to_id[4].menuid); break; }
					case SDLK_5: case SDLK_KP5: { BuyItem(game_vars::shop::g_key_to_id[5].menuid); break; }
					case SDLK_6: case SDLK_KP6: { BuyItem(game_vars::shop::g_key_to_id[6].menuid); break; }
					case SDLK_7: case SDLK_KP7: { BuyItem(game_vars::shop::g_key_to_id[7].menuid); break; }
					case SDLK_8: case SDLK_KP8: { BuyItem(game_vars::shop::g_key_to_id[8].menuid); break; }
					case SDLK_UP:
					{
						menuPosId = game_vars::shop::g_pmenu->GetCursorPosition();
						if (menuPosId > 0)  // cote droit
							game_vars::shop::g_pmenu->SignalCursorMove(M_CUR_LEFT);
						else
							game_vars::shop::g_pmenu->SignalCursorMove(M_CUR_RIGHT);
						break;
					}
					case SDLK_DOWN:
					{
						menuPosId = game_vars::shop::g_pmenu->GetCursorPosition();
						if (menuPosId > 0)  // cote droit
							game_vars::shop::g_pmenu->SignalCursorMove(M_CUR_RIGHT);
						else
							game_vars::shop::g_pmenu->SignalCursorMove(M_CUR_LEFT);
						break;
					}
					case SDLK_LEFT:
					{
						game_vars::shop::g_pmenu->SignalCursorMove(M_CUR_LEFT);
						break;
					}
					case SDLK_RIGHT:
					{
						game_vars::shop::g_pmenu->SignalCursorMove(M_CUR_RIGHT);
						break;
					}
					case SDLK_q:
					case SDLK_ESCAPE:
					{
						game_vars::shop::g_menuActivated = false;
						break;
					}
					case SDLK_RETURN:
					case SDLK_SPACE:
					{	// achat d'un objet ou selection d'une arme et sortie du menu
						BuyItem(game_vars::shop::g_pmenu->GetCursorPosition());
						break;
					}
					default:
						break;
				}
		}
	}
}

void FlushEvents(void)
{
	SDL_Event e;
	int retval = 1;
	while (retval != 0)
	{
		retval = SDL_PollEvent(&e);
	}
}

bool EventPending(void)
{
	return SDL_PollEvent(0);
}

// attend un evennement sans trop utiliser le processeur pendant un temps limité avant de retourner
int TimedWaitEvent(SDL_Event* e, int ms)
{
	tools::HiResTimer timer;
	timer.Start();
	int retval = 0;

	bool expired = false;
	while (!expired && retval == 0)
	{
		retval = SDL_PollEvent(e);
		if (retval == 0)
			tools::HiResTimer::Sleep(10);  // 10 ms de dodo CPU
		expired = timer.GetTime() * 1000.0 > (double)ms;
	}
	return retval;
}

EKeyboardMenuEntries HandleMenuEvent(int wait)
{
	SDL_Event event;
	if (TimedWaitEvent(&event, wait))  // force le retour apres 100 ms d'attente
	{
		switch (event.type)
		{
			case SDL_QUIT:
				return KBME_EXIT;
			case SDL_KEYDOWN:
				switch (event.key.keysym.sym)
				{
					case SDLK_DOWN:   return KBME_DOWN;
					case SDLK_UP:     return KBME_UP;
					case SDLK_LEFT:   return KBME_LEFT;
					case SDLK_RIGHT:  return KBME_RIGHT;
					case SDLK_RETURN: return KBME_VALIDATE;
					case SDLK_ESCAPE: return KBME_EXIT;
					case SDLK_END:    return KBME_END;
					case SDLK_HOME:   return KBME_HOME;
					case SDLK_RCTRL:
					case SDLK_LCTRL:  return KBME_CTRL;
					default:          return KBME_UNHANDLED;
				}
				break;
			case SDL_KEYUP:
				switch (event.key.keysym.sym)
				{
					case SDLK_DOWN:  return KBME_KUP_DOWN;
					case SDLK_UP:    return KBME_KUP_UP;
					case SDLK_LEFT:  return KBME_KUP_LEFT;
					case SDLK_RIGHT: return KBME_KUP_RIGHT;
					case SDLK_RCTRL:
					case SDLK_LCTRL: return KBME_KUP_CTRL;
					default:         return KBME_KUP_UNHANDLED;
				}
		}
	}
	return KBME_NONE;
}
