/**********************************************************************
 * File  : rendersurfaces.hpp
 * Author: Lightness1024
 *         mailto:lightness1024@free.fr
 * Date  : 07/03/2009

 *********************************************************************/

#ifndef SHAREDSURFACE_HPP_INC_07_03_2009___129471333_
#define SHAREDSURFACE_HPP_INC_07_03_2009___129471333_ 1

struct SDL_Surface;

namespace render2d
{
	enum EDestroyPolicy
	{
		DP_QUIT_SDL,  // va detruire la SDL a la destruction
		DP_WEAK,      // ne fait rien
		DP_NO_POLICY
	};
	
	class SDLLife
	{
	public:
		SDLLife(EDestroyPolicy policy = DP_QUIT_SDL);
		~SDLLife();
		static void ManuallyQuitSDL();
		static void ManuallyInitSDL();
		
	protected:
		static int GetInstances() { return instances; }
		
	private:
		struct Cant_Use_SDL_After_It_Has_Been_Quit {};
		struct Cant_Quit_SDL_While_Lives_Exist {};

		static bool initDone;
		static bool quitDone;
		static EDestroyPolicy firstPolicy;
		static int instances;
	};
	
	class SharedSurface : private SDLLife
	{
	public:
		
		SharedSurface();
		SharedSurface(int resx, int resy, EDestroyPolicy policy = DP_QUIT_SDL);
		~SharedSurface();
		int GetX(void) const { return x_; }
		int GetY(void) const { return y_; }
		SDL_Surface* SdlPtr(void) const { return surf; }
		static bool Exists() { return surf != 0; }

	private:
		struct No_Reference_Surface {};
		struct Cant_Create_Window {};

		static SDL_Surface* surf;
		static int x_;
		static int y_;
	};
}

#endif //SHAREDSURFACE_HPP_INC_07_03_2009___129471333_
