/**********************************************************************
 * File  : solardiales.hpp
 * Author: Lightness1024
 *         mailto:lightness1024@free.fr
 * Date  : 05/05/2009
 *********************************************************************/

#ifndef SOLARDIALES_HPP_INC_05_05_2009___23197726_
#define SOLARDIALES_HPP_INC_05_05_2009___23197726_ 1

#include "terraingenerator.hpp"
#include "carsmanager.hpp"
#include "hud.hpp"

enum ESESSetOnOff
{
	SES_ON,
	SES_OFF
};

void SetEngineSound(ESESSetOnOff setting = SES_ON);

int GetIndexOfPlayer(std::string const& name);
char const * GetPlayerFromIndex(int index);
std::string MakeBmpFN(char const* name);

inline float GetFastSpeed()
{
	return 4.0f;
}

inline float GetNormalSpeed()
{
	return 2.0f;
}

struct SoundSettings
{
	int musicVolume;
};

template< typename T >
class MakeDiff
{
	T oldval;
	bool init;

public:

	MakeDiff(void) : oldval(tools::trait::Zero<T>::value), init(false) {}

	T GetDiff(T newval)
	{
		if (!init)
		{
			oldval = newval;
			init = true;
		}
		T retval = newval - oldval;
		oldval = newval;
		return retval;
	}
};

struct GameInfos
{
	int seed;
	int resx;
	int resy;
	TerrainParameters param;
	int pickedPlayer;
	int musicVolume;
	int enemiesFlow;
};

namespace game_vars
{
	int const evil_value = 666666;

	extern int gameover;
	extern bool g_score_is_acceptable;
	extern Vector2f g_scrPos;
	extern CarsManager::CarAcsor g_user;
	extern bool g_cheat;
	extern int g_currentWeapon;
	extern bool g_keyleft;
	extern bool g_keyright;
	extern int g_minigun_id;
	extern int g_heavymg_id;
	extern int g_rocketl_id;
	extern int g_superfg_id;
	extern int g_qsuperfg_id;
	extern bool g_carControlDevice;
	extern size_t g_playerIAClassID;
	extern size_t g_simpleIAClassID;
	extern size_t g_strongIAClassID;
	
	namespace shop
	{
		extern bool g_menuActivated;
		extern Menu* g_pmenu;
		extern int g_ccd_id;  // id des upgrades
		extern int g_shield_id;
		struct TwoIDs
		{
			int menuid;
			int spriteid;
		};
		typedef std::map< int, TwoIDs > NumToIDs;
		extern NumToIDs g_key_to_id;

		int const shield_value = 1000;
	}
}


#endif //SOLARDIALES_HPP_INC_05_05_2009___23197726_
