/**********************************************************************
 * File	: circularlist.hpp
 * Author: Lightness1024
 *			  mailto:lightness1024@free.fr
 * Date	: 17/07/2007
 *********************************************************************/

#ifndef CIRCULARLIST_HPP_INC_19_03_2009___186237008_
#define CIRCULARLIST_HPP_INC_19_03_2009___186237008_ 1

#include <vector>
using std::vector;

template< typename T >
class CircularList
{
	vector< T > v;
		
	unsigned int first;
	unsigned int last;
	int m_size;
		
public:

	void push_back(const T& ref)
	{
		if (m_size > 0)
			++last %= v.size();	// on avance last
		// last "pousse" first :
		if (last == first && m_size > 0)
			++first %= v.size();
		else
			++m_size;	// on augmente la taille si on pousse pas first.
		// copie:
		v[last] = ref;			
	}

	void pop_front(void)
	{
		if (m_size > 0 && last != first)
		{
			++first %= v.size();
			--m_size;
		}
		else if (m_size > 0)	 // reste un seul element
		{
			--m_size;
		}
	}
		
	void pop(int pos)
	{
		if (m_size > 0)
		{
			T tmp = v[first];
			v[first] = (*this)[pos];
			(*this)[pos] = tmp;
			pop_front();
		}
	}
		
	int size(void)
	{
		return m_size;
	}
		
	T& operator [] (int i)
	{
		return v[(i + first) % v.size()];
	}

	const T& operator [] (int i) const
	{
		return v[(i - first) % v.size()];
	}
		
	void resize(int sz)
	{
		v.clear();
		v.resize(sz);
		first = 0;
		last = 0;
		m_size = 0;
	}
		
	CircularList(void)
	{
		first = 0;
		last = 0;
		m_size = 0;
	}
};

#endif //CIRCULARLIST_HPP_INC_19_03_2009___186237008_
