/**********************************************************************
 * File  : myutils.hpp
 * Author: Lightness1024
 *         mailto:lightness1024@free.fr
 * Date  : 22/03/2009
 *********************************************************************/

#ifndef MYUTILS_HPP_INC_22_03_2009___108078142_
#define MYUTILS_HPP_INC_22_03_2009___108078142_ 1

#include <algorithm>

namespace myutils
{
	template< typename T >
	inline T clamp(T const & val, T const & min, T const & max)
	{
		return std::max(std::min(val, max), min);
	}

	template< typename T >
	inline T abs(T const & a)
	{
		return std::max(a, -a);
	}
	
	template< typename T >
	inline T dist(T const& a, T const& b)
	{
		return std::abs(a - b);
	}
	
	template< typename T >
	inline T sign(const T& val)
	{
		return (val > 0) ? static_cast<T>(1) : static_cast<T>(-1);
	}

}


#endif //MYUTILS_HPP_INC_22_03_2009___108078142_
