/**********************************************************************
 * File  : timer.inl
 * Date  : 19/03/2009
 *********************************************************************/

#if defined(TIMER_INL_INC_19_03_2009___240537633_)
 #error "you can't include a .inl two times in a row"
#endif

#if !defined(TIMER_HPP_INC_19_03_2009__28917117_)
 #error "header needed before the definitions"
#endif

#define TIMER_INL_INC_19_03_2009___240537633_ 1

#include "type_traits.hpp"

namespace tools
{
	HiResTimer::HiResTimer()
			: bRun_(false)
	{
		Reset();
	}
	HiResTimer::HiResTimer(ERunMode mode)
			: bRun_(false)
	{
		Reset();
		if (mode == RM_STARTED)
			Start();
	}
	void HiResTimer::Reset()
	{
		if (bRun_)
			start_ = GetSysTime();
		total_ = trait::Zero<OSSpecTime_t>::value;
	}

	double HiResTimer::GetTime() const
	{
		if (bRun_)
		{
			OSSpecTime_t cur = GetSysTime();
			cur += total_;
			cur = cur - start_;
			return ToSeconds(cur);
		}
		else
		{
			return ToSeconds(total_);
		}
	}

	double HiResTimer::Stop()
	{
		if (bRun_)
		{
			bRun_ = false;
			OSSpecTime_t cur = GetSysTime();
			total_ += (cur - start_);
		}
		return ToSeconds(total_);
	}

	void HiResTimer::Start()
	{
		if (!bRun_)
		{
			start_ = GetSysTime();
			bRun_ = true;
		}
	}

	// static
	void HiResTimer::Sleep(int ms)
	{
		MilliSleep(ms);
	}
}
