/**********************************************************************
 * File  : tl_mach_osstime.h
 * Author: Lightness1024
 *         mailto:lightness1024@free.fr
 * Date  : 19/03/2009
 *********************************************************************/

#ifndef TL_MACH_OSSTIME_H_INC_19_03_2009___134570509_
#define TL_MACH_OSSTIME_H_INC_19_03_2009___134570509_ 1

#include <CoreServices/CoreServices.h>
#include <mach/mach.h>
#include <mach/mach_time.h>
#include <unistd.h>

// mach implementation
namespace tools
{
	struct OSSpecTime_t
	{
		OSSpecTime_t operator - (OSSpecTime_t const & right) const
		{
			OSSpecTime_t t;
			t.val_ = val_ - right.val_;
			return t;
		}
		OSSpecTime_t& operator += (OSSpecTime_t const & right)
		{
			val_ += right.val_;
			return *this;
		}
		uint64_t val_;
	};
	inline OSSpecTime_t GetSysTime()
	{
		OSSpecTime_t t;
		t.val_ = mach_absolute_time();
		return t;
	}
	inline double ToSeconds(OSSpecTime_t const & osst_t)
	{
		Nanoseconds elapsedNano;
		elapsedNano = AbsoluteToNanoseconds( *(AbsoluteTime*) &osst_t.val_ );
		uint64_t nanos = *(uint64_t*) &elapsedNano;
		return 1e-9 * static_cast< double >(nanos);
	}
	inline void MilliSleep(int ms)
	{
		usleep(ms * 1000);
	}
}

#endif //TL_MACH_OSSTIME_H_INC_19_03_2009___134570509_
