/**********************************************************************
 * File  : tl_win_osstime.h
 * Author: Lightness1024
 *         mailto:lightness1024@free.fr
 * Date  : 19/03/2009
 *********************************************************************/

#ifndef TL_WIN_OSSTIME_H_INC_19_03_2009___156121923_
#define TL_WIN_OSSTIME_H_INC_19_03_2009___156121923_ 1

namespace tools
{
	struct OSSpecTime_t
	{
		OSSpecTime_t operator - (OSSpecTime_t const & right) const
		{
			OSSpecTime_t t;
			t.val_.QuadPart = val_.QuadPart - right.val_.QuadPart;
			return t;
		}
		OSSpecTime_t& operator += (OSSpecTime_t const & right)
		{
			val_.QuadPart += right.val_.QuadPart;
			return *this;
		}
		LARGE_INTEGER val_;
	};
	inline OSSpecTime_t GetSysTime()
	{
		OSSpecTime_t t;
		QueryPerformanceCounter(&t.val_);
		return t;
	}
	inline double ToSeconds(OSSpecTime_t const & osst_t)
	{
		static LARGE_INTEGER liFrequency;
		if (liFrequency.QuadPart == 0)
		{
			QueryPerformanceFrequency(&liFrequency);
		}
		return (double)(osst_t.val_.QuadPart) / (double)(liFrequency.QuadPart);
	}
	inline void MilliSleep(int ms)
	{
		::Sleep(ms);
	}
}


#endif //TL_WIN_OSSTIME_H_INC_19_03_2009___156121923_
